RegionReadonlyProperties:
  type: object
  properties:
    id:
      type: integer
      description: Идентификатор региона
      example: 1
    created_at:
      description: "Дата создания"
      format: date-time
      type: string
      example: "2021-01-29T12:36:13.000000Z"
    updated_at:
      description: "Дата обновления"
      format: date-time
      type: string
      example: "2021-01-29T12:36:13.000000Z"
RegionFillableProperties:
  type: object
  properties:
    federal_district_id:
      type: integer
      description: Id федерального округа
      example: 1
    name:
      type: string
      description: Название
      example: "Московская обл"
    guid:
      type: string
      description: Id ФИАС
      example: "29251dcf-00a1-4e34-98d4-5c47484a36d4"
RegionRequiredProperties:
  type: object
  required:
    - federal_district_id
    - name
    - guid
RegionIncludes:
  type: object
  properties:
    cities:
      description: "Населенные пункты, в которые возможна доставка"
      type: array
      items:
        $ref: './cities.yaml#/City'
Region:
  allOf:
    - $ref: '#/RegionReadonlyProperties'
    - $ref: '#/RegionFillableProperties'
    - $ref: '#/RegionIncludes'

CreateRegionRequest:
  allOf:
    - $ref: '#/RegionFillableProperties'
    - $ref: '#/RegionRequiredProperties'
ReplaceRegionRequest:
  allOf:
    - $ref: '#/RegionFillableProperties'
    - $ref: '#/RegionRequiredProperties'
PatchRegionRequest:
  allOf:
    - $ref: '#/RegionFillableProperties'

SearchRegionsFilter:
  type: object
  properties:
    id:
      type: integer
      description: Идентификатор региона
      example: 1
    federal_district_id:
      type: integer
      description: Id федерального округа
      example: 1
    name:
      type: string
      description: Название
      example: "Московская обл"
    guid:
      type: string
      description: Id ФИАС
      example: "29251dcf-00a1-4e34-98d4-5c47484a36d4"

SearchRegionsRequest:
  type: object
  properties:
    sort:
      $ref: '../../common_schemas.yaml#/RequestBodySort'
    filter:
      allOf:
        - type: object
        - $ref: '#/SearchRegionsFilter'
    include:
      type: array
      items:
        type: string
        description: Подгружаемые связанные сущности
        enum:
          - federal_district
          - delivery_prices
          - cities
      example:
        - federal_district
        - delivery_prices
        - cities
    pagination:
      $ref: '../../common_schemas.yaml#/RequestBodyPagination'

RegionResponse:
  type: object
  properties:
    data:
      $ref: '#/Region'
    meta:
      type: object
  required:
    - data
SearchRegionsResponse:
  type: object
  properties:
    data:
      type: array
      items:
        $ref: '#/Region'
    meta:
      type: object
      properties:
        pagination:
          $ref: '../../common_schemas.yaml#/ResponseBodyPagination'
  required:
    - data
    - meta
